// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

cr.plugins_.VinoosWAStickers = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{	
	var pluginProto = cr.plugins_.VinoosWAStickers.prototype;
		
/////////////////////////////////////
// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

	var errorMessage = "";
	var _identifier = "";
	
// called on startup for each object type
	typeProto.onCreate = function()
	{
		if(this.runtime.isBlackberry10 || this.runtime.isWindows8App || this.runtime.isWindowsPhone8 || this.runtime.isWindowsPhone81){
			var scripts=document.getElementsByTagName("script");
			var scriptExist=false;
			for(var i=0;i<scripts.length;i++){
				if(scripts[i].src.indexOf("cordova.js")!=-1||scripts[i].src.indexOf("phonegap.js")!=-1){
					scriptExist=true;
					break;
				}
			}
			if(!scriptExist){
				var newScriptTag=document.createElement("script");
				newScriptTag.setAttribute("type","text/javascript");
				newScriptTag.setAttribute("src", "cordova.js");
				document.getElementsByTagName("head")[0].appendChild(newScriptTag);
			}
		}
	};

/////////////////////////////////////
// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	
	var instanceProto = pluginProto.Instance.prototype;
	
	var isSupported = false;
	
// called whenever an instance is created
	instanceProto.onCreate = function()
	{
		if (!window["WhatsAppStickers"])
		{
			cr.logexport("[Construct 2] miladesign.cordova.wastickers.WhatsAppStickers is required to add stickers with Cordova; other platforms are not supported");
			return;
		}
		
		isSupported = true;
		
		/*var self = this;
		
		document.addEventListener('onError',function(data){
			errorMessage = data.message;
			self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddStickerFailed, self);
		});
		
		document.addEventListener('onSuccess',function(data){
			self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddStickerSuccess, self);
		});*/
	};
	
	instanceProto.draw = function(ctx)
	{
	};
	instanceProto.drawGL = function (glw)
	{
	};

//////////////////////////////////////
// Conditions
	function Cnds() {};

	Cnds.prototype.onAddGlobalFailed = function () {
		return true;
	};
	
	Cnds.prototype.onAddGlobalSuccess = function () {
		return true;
	};

	Cnds.prototype.onAddSingleFailed = function (identifier) {
		return (_identifier === identifier);
	};
	
	Cnds.prototype.onAddSingleSuccess = function (identifier) {
		return (_identifier === identifier);
	};
	
	pluginProto.cnds = new Cnds();
	
//////////////////////////////////////
// Actions
	function Acts() {};
	
	Acts.prototype.addStickerToWhatsApp = function (identifier, name) {
		if (!isSupported)
			return;
		
		var self = this;
		
		_identifier = identifier;
		
		jsonObject = { "identifier": identifier, "name": name };
		json = JSON.stringify(jsonObject);
		
		WhatsAppStickers.addToWhatsApp(
			json,
			function() {
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddGlobalSuccess, self);
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddSingleSuccess, self);
			},
			function(e) {
				errorMessage = e;
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddGlobalFailed, self);
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddSingleFailed, self);
			}
		);
	};
	
	Acts.prototype.addStickerToWhatsApp2 = function (json) {
		if (!isSupported)
			return;
		
		var self = this;
		
		obj = JSON.parse(json);
		_identifier = obj['identifier'];
		
		WhatsAppStickers.addToWhatsApp(
			json,
			function() {
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddGlobalSuccess, self);
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddSingleSuccess, self);
			},
			function(e) {
				errorMessage = e;
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddGlobalFailed, self);
				self.runtime.trigger(cr.plugins_.VinoosWAStickers.prototype.cnds.onAddSingleFailed, self);
			}
		);
	};
	
	pluginProto.acts = new Acts();
	
//////////////////////////////////////
// Expressions
	function Exps() {};

	Exps.prototype.ErrorMessage = function (ret) {
		ret.set_string(errorMessage);
	};
	
	pluginProto.exps = new Exps();

}());